/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.workflow.action;

import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.workflow.dto.AmRouteDto;
import jp.mosp.kintai.workflow.dto.AmUnitDto;
import jp.mosp.kintai.workflow.vo.ApprovalRouteCardVo;

/**
 * @author yoshida
 *
 */
public class ApprovalRouteCardAction extends MosPWorkflowAction {
	
	// コマンド
	private static final String	CMD_ROUTE_CARD_SHOW		= "S2825";	// 表示(追加)
	private static final String	CMD_ROUTE_CARD_SELECT	= "S2826";	// 表示(選択)
	private static final String	CMD_ROUTE_CARD_INSERT	= "S2827";	// 登録
	private static final String	CMD_ROUTE_CARD_UPDATE	= "S2828";	// 更新
																	
	
	/**
	 * コンストラクタ
	 */
	public ApprovalRouteCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_ROUTE_CARD_SHOW)) {
			show();
		} else if (cmd.equals(CMD_ROUTE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_ROUTE_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_ROUTE_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new ApprovalRouteCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// プルダウンのセット
		ApprovalRouteCardVo vo = (ApprovalRouteCardVo)getVo();
		// 承認ユニットコード一覧
		vo.aryPltUnit = getUnitArrayAvailable();
		vo.setParams(request);
	}
	
	@Override
	protected void show() throws Exception {
		ApprovalRouteCardVo vo = (ApprovalRouteCardVo)getVo();
		vo.setDefaultValues();
		// モード設定
		setMode();
	}
	
	@Override
	protected void select() throws Exception {
		ApprovalRouteCardVo vo = (ApprovalRouteCardVo)getVo();
		// データの取得
		AmRouteDto dto = routeDao().findForKey(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(ApprovalRouteCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		ApprovalRouteCardVo vo = (ApprovalRouteCardVo)getVo();
		// パラメータの妥当性確認
		vo.validate();
		// 存在チェック
		chkDuplicate(routeDao().findForKey(vo.getTxtRouteCode()));
		// DTOの準備
		AmRouteDto dto = new AmRouteDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		// データの挿入
		routeDao().insert(dto);
		// DTOの再取得
		dto = routeDao().findForKey(dto.getRtCode());
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		AmRouteDto dto = (AmRouteDto)getSessionDto();
		ApprovalRouteCardVo vo = (ApprovalRouteCardVo)getVo();
		// コード取得
		vo.setTxtRouteCode(dto.getRtCode());
		// パラメータの妥当性確認
		vo.validate();
		// 排他確認
		chkExclusive(dto, routeDao().findForUpdate(vo.getTxtRouteCode()));
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		routeDao().update(dto);
		// DTOの再取得
		AmRouteDto retDto = routeDao().findForKey(dto.getRtCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * 承認ユニットコード取得（AM_UNIT）
	 * @return 利用可能な承認ユニットコードリスト
	 * @throws Exception 	例外処理が発生した場合
	 */
	private String[][] getUnitArrayAvailable() throws Exception {
		// 情報の取得
		List<AmUnitDto> listUnit = unitDao().findForSelectableUnitArray(
				DateUtil.convDateFormattedByHyphen(DateUtil.getSystemDate()));
		// 配列の作成
		String[][] aryUnit = new String[listUnit.size()][3];
		for (int i = 0; i < aryUnit.length; i++) {
			aryUnit[i][0] = listUnit.get(i).getUnitCode();
			StringBuffer sb = new StringBuffer();
			sb.append(getKName(listUnit.get(i).getMain()));
			sb.append(CommonConst.STR_2BYTE_SLASH_SEPARATOR);
			sb.append(getKName(listUnit.get(i).getAgent()));
			sb.append(CommonConst.BRACKET_LEFT);
			sb.append(DateUtil.convDateToFormatDateJPShort(listUnit.get(i).getStartDate()));
			sb.append(CommonConst.STR_TERM);
			sb.append(CommonConst.BRACKET_RIGHT);
			aryUnit[i][1] = sb.toString();
		}
		return aryUnit;
	}
	
	/**
	 * モード設定
	 */
	private void setMode() {
		ApprovalRouteCardVo vo = (ApprovalRouteCardVo)getVo();
		// モード設定
		if (vo.aryPltUnit.length == 0) {
			vo.setMode(ApprovalRouteCardVo.MODE_IMPOSSIBLE);
		} else {
			vo.setMode(ApprovalRouteCardVo.MODE_INSERT);
		}
	}
	
}
